### 查询数据

##### 写入

1、一天一次产生的统计数据

通过tornado框架实现数据cron的运行及查询接口，cron定期将昨日的数据写入大数据平台，基本结构如下：

| 名称        | 类型       | 必填项 | 说明                                                         |
| ----------- | ---------- | ------ | ------------------------------------------------------------ |
| gameid      | 游戏ID     | 是     |                                                              |
| channelid   | 平台ID     | 是     |                                                              |
| #event_name | 事件类型   | 是     | 所有事件均定义为event_{事件名}_01                            |
| date        | 报表日期   | 是     |                                                              |
| result      | 具体的数据 | 是     | 以json格式存放的数据，每条记录为1个dict如{'name':'a','num':123}，如数据为多条，则产生多条记录 |



Event定义表

| 名称     | 说明             | 主要字段                                                     | 对应event类型 | 通用性    | 新用户 |
| -------- | ---------------- | ------------------------------------------------------------ | ------------- | --------- | ------ |
| share    | 分享记录统计     | 分享人数/人次/由分享进入人数/人次                            | event_11_10   | Y         | Y      |
| tap      | 按钮点击记录     | 按拆分的button_name，button_param进行数据统计                | event_11_31   | 1016,1004 | Y      |
| stage    | 关卡通关记录     |                                                              | event_11_31   | 1004      | Y      |
| ad_video | 分析广告观看视频 | 按activity_id=2 and activity_param like '%"isEnded":false%'规则统计观看视频 | evnt_11_21    | 1004,1016 | Y      |
| ad       | 广告记录         | 上一列的数据可包含进来？？                                   |               |           |        |
| shop     | 购买记录         | 按拆分的button_name，button_subname字段进行统计              | event_11_31   | 1016      | Y      |
| item     | 道具相关         |                                                              |               |           |        |
|          | 基础游戏数据     | 按fromappid,channel统计                                      | event_11_1    | Y         |        |
| retain   | 留存数据         | 按fromappid,channel统计                                      | event_11_1    | Y         |        |

base及retain实现存储在mysql中，脚本集中在ops_job处，本次不做修改

其它脚本将放置在report目录，但所有统计数据通过一个接口返回数据





2、以时间戳为主键的数据（间隔5/1分钟）

数据产生流程为每间隔一个时间执行统计脚本，数据写入influxdb，tag有gameid，channelid，serverid，date，通过接口返回数据给前端进行绘图展示。

实时统计数据包括 ：分享引新、当日活跃用户数、累计注册、当日登录次数、新用户、分享次数、分享人数、次日留存、7日留存

##### 展示

